#ifndef RK_DNSPACK_MAKEDIRECTORY_H
#define RK_DNSPACK_MAKEDIRECTORY_H

#include <string>

namespace rk
{
	namespace dnspack
	{
		class MakeDirectory
		{
		public:
			MakeDirectory(const std::string& parentDirectoryPath, const std::string& childDirectoryName);
			virtual ~MakeDirectory();

			bool operator()(); // Windows : If child directory already exists, return false

		private:
			std::string m_parentDirectoryPath;
			std::string m_childDirectoryName;

		private:
			MakeDirectory(const MakeDirectory&) = delete;
			MakeDirectory(MakeDirectory&& other) noexcept = delete;
			MakeDirectory& operator=(const MakeDirectory& other) = delete;
			MakeDirectory& operator=(MakeDirectory&& other) noexcept = delete;
		};
	}
}


#endif // !RK_DNSPACK_MAKEDIRECTORY_H
