#ifndef RK_DNSPACK_RANDOMGENERATE_H
#define RK_DNSPACK_RANDOMGENERATE_H

#include <valarray>

#include "BasisComposition.h"
#include "PackingStructure.h"

namespace rk
{
	namespace dnspack
	{
		class RandomGenerate
		{
		public:
			explicit RandomGenerate(const BasisComposition& basisComposition);
			virtual ~RandomGenerate();

		public:
			PackingStructure operator()();

		private:
			const BasisComposition& m_basisComposition;
			const std::size_t m_spheresNumber;

		private:
			RandomGenerate(const RandomGenerate& other) = delete;
			RandomGenerate(RandomGenerate&& other) noexcept = delete;
			RandomGenerate& operator=(const RandomGenerate& other) = delete;
			RandomGenerate& operator=(RandomGenerate&& other) noexcept = delete;
		};
	}
}


#endif // !RK_DNSPACK_RANDOMGENERATE_H
