#ifndef RK_DNSPACK_SETTRIALBASISCOMPOSITION_H
#define RK_DNSPACK_SETTRIALBASISCOMPOSITION_H

#include <vector>

#include "ReadInputFile.h"
#include "BasisComposition.h"

namespace rk
{
	namespace dnspack
	{
		class SetTrialBasisComposition
		{
		public:
			SetTrialBasisComposition(const std::vector<SphereInfo>& sphereInfo, const int minimumSpheresNumber, int maximumSpheresNumber);
			virtual ~SetTrialBasisComposition();

			void operator()(std::vector<BasisComposition>& trialBasisComposition);

		private:
			std::vector<SphereInfo> m_sphereInfo;

			const int m_minimumSpheresNumber;
			const int m_maximumSpheresNumber;

		private:
			SetTrialBasisComposition(const SetTrialBasisComposition&) = delete;
			SetTrialBasisComposition(SetTrialBasisComposition&&) noexcept = delete;
			SetTrialBasisComposition& operator=(const SetTrialBasisComposition&) = delete;
			SetTrialBasisComposition& operator=(SetTrialBasisComposition&&) noexcept = delete;
		};
	}
}


#endif // !RK_DNSPACK_SETTRIALBASISCOMPOSITION_H
