#include "Argument.h"

#include <iostream>
#include <regex>

using namespace rk::dnspack;

Argument::Argument()
	: m_inputFileName{}
{
}

Argument::~Argument()
{
}

void Argument::usage() noexcept
{
	std::cout << "usage: SearchDensestPackings.exe\n";
	std::cout << "   -i: input file name\n";
}

bool Argument::parse(int argc, char* argv[])
{
	bool result = true;

	for (int i = 1; i < argc; ++i)
	{
		std::string argvString(argv[i]);

		if (argvString == "-i")
		{
			if (argc <= i + 1)
			{
				result = false;
				break;
			}
			m_inputFileName = argv[++i];
		}
	}

	if (m_inputFileName.empty())
	{
		return false;
	}

	return result;
}
