#include "BasisComposition.h"

using namespace rk::dnspack;

BasisComposition::BasisComposition()
	: m_numbers()
	, m_radii()
{
}

BasisComposition::BasisComposition(const std::set<double>& radii, const std::map<double, int>& numbers)
	: m_radii(radii)
	, m_numbers(numbers)
{
	if (m_radii.size() != m_numbers.size())
	{
		throw std::invalid_argument("BasisComposition(std::set<double>& radii, const std::map<double, int>& numbers) -> the container size is different.");
	}
}

BasisComposition::BasisComposition(std::set<double>&& radii, std::map<double, int>&& numbers)
	: m_radii(std::move(radii))
	, m_numbers(std::move(numbers))
{
	if (m_radii.size() != m_numbers.size())
	{
		throw std::invalid_argument("BasisComposition(std::set<double>& radii, const std::map<double, int>& numbers) -> the container size is different.");
	}
}

BasisComposition::~BasisComposition()
{
}
