#include "BravaisLattice.h"

using namespace rk::dnspack;

BravaisLattice::BravaisLattice() noexcept
	: m_latticeVectors{ {0,0,0}, {0,0,0}, {0,0,0} }
{
}

BravaisLattice::~BravaisLattice()
{
}

BravaisLattice::BravaisLattice(const BravaisLattice& other) noexcept
	: m_latticeVectors{ other.m_latticeVectors[0], other.m_latticeVectors[1], other.m_latticeVectors[2] }
{
}

BravaisLattice::BravaisLattice(BravaisLattice&& other) noexcept
	: m_latticeVectors{ other.m_latticeVectors[0], other.m_latticeVectors[1], other.m_latticeVectors[2] }
{
}

double BravaisLattice::getVolume() const noexcept
{
	CartesianCoordinate vec1xVec2;
	{
		vec1xVec2.x = m_latticeVectors[1].y * m_latticeVectors[2].z - m_latticeVectors[1].z * m_latticeVectors[2].y;
		vec1xVec2.y = m_latticeVectors[1].z * m_latticeVectors[2].x - m_latticeVectors[1].x * m_latticeVectors[2].z;
		vec1xVec2.z = m_latticeVectors[1].x * m_latticeVectors[2].y - m_latticeVectors[1].y * m_latticeVectors[2].x;
	}

	double volume = innerProduct(m_latticeVectors[0], vec1xVec2);

	return volume;
}